// another fine solution by misof
#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
using namespace std;

int R, S, P=1000000009, N, K;
vector< vector<int> > C;

void init_small() {
  C.clear();
  C.resize(R+1, vector<int>(S+1) );
  for (int r=0; r<=R; ++r) for (int s=0; s<=S; ++s) {
    if (r==0 || s==0)
      C[r][s] = 1;
    else {
      C[r][s] = C[r-1][s] + C[r][s-1];
      if (C[r][s] > P) C[r][s] -= P;
    }
  }
}

bool distless(const pair<int,int> &A, const pair<int,int> &B) {
  return A.first + A.second < B.first + B.second;
}

int main() {
  freopen("mravenci.in", "r", stdin);
  freopen("mravenci.out", "w", stdout);
  scanf("%d%d%d",&R,&S,&N);
  init_small();
  while (N--) {
    scanf("%d",&K);
    vector< pair<int,int> > prekazky;
    for (int k=0; k<K; ++k) { 
      int x,y;
      scanf("%d%d",&x,&y);
      prekazky.push_back( make_pair(x,y) );
    }
    prekazky.push_back( make_pair(R,S) );
    sort( prekazky.begin(), prekazky.end(), distless );
    vector<long long> G(K+1);
    for (int k=0; k<=K; ++k) G[k] = C[ prekazky[k].first ][ prekazky[k].second ];
    for (int k=0; k<K; ++k)
      for (int l=k+1; l<=K; ++l)
        if (prekazky[l].first >= prekazky[k].first && prekazky[l].second >= prekazky[k].second) {
          G[l] -= G[k] * C[ prekazky[l].first - prekazky[k].first ][ prekazky[l].second - prekazky[k].second ];
          G[l] %= P;
          if (G[l] < 0) G[l] += P;
        }
    cout << G[K] << endl;
  }
}
