// another fine solution by misof
#include <algorithm>
#include <vector>
#include <cstdio>
#include <iostream>
using namespace std;

int R, S, P=1000000009, N, K;

bool distless(const pair<int,int> &A, const pair<int,int> &B) {
  return A.first + A.second < B.first + B.second;
}

vector<int> prvocisla(1,2);
bool je_prvocislo(int N) { for (int i=2; i*i<=N; ++i) if (N%i==0) return false; return true; }

inline int moc(int N, int p) {
  int result = 0;
  while (N) { N/=p; result+=N; }
  return result;
}

inline int C(int N, int K) {
  long long result = 1;
  for (int p=0; prvocisla[p]<=N; ++p) {
    int mocnina = moc(N,prvocisla[p]) - moc(K,prvocisla[p]) - moc(N-K,prvocisla[p]);
    while (mocnina--) result = (result * prvocisla[p]) % P;
  }
  return result;
}

int main() {
  freopen("mravenci.in", "r", stdin);
  freopen("mravenci.out", "w", stdout);
  scanf("%d%d%d",&R,&S,&N);

  for (int i=3; i<=R+S+2; i+=2) if (je_prvocislo(i)) prvocisla.push_back(i);
  prvocisla.push_back(R+S+47);
  
  while (N--) {
    scanf("%d",&K);
    vector< pair<int,int> > prekazky;
    for (int k=0; k<K; ++k) { 
      int x,y;
      scanf("%d%d",&x,&y);
      prekazky.push_back( make_pair(x,y) );
    }
    prekazky.push_back( make_pair(R,S) );
    sort( prekazky.begin(), prekazky.end(), distless );
    vector<long long> G(K+1);
    for (int k=0; k<=K; ++k) G[k] = C( prekazky[k].first+prekazky[k].second, prekazky[k].first );
    for (int k=0; k<K; ++k)
      for (int l=k+1; l<=K; ++l) {
        int dx = prekazky[l].first - prekazky[k].first, dy = prekazky[l].second - prekazky[k].second;
        if (dx<0 || dy<0) continue;
        G[l] -= G[k] * C(dx+dy,dx);
        G[l] %= P;
        if (G[l] < 0) G[l] += P;
      }
    cout << G[K] << endl;
  }
}
